题目链接:https://leetcode.cn/problems/single-number/

给定一个非空整数数组,除了某个元素只出现一次以外,其余每个元素均出现两次。找出那个只出现了一次的元素。

说明:

你的算法应该具有线性时间复杂度。 你可以不使用额外空间来实现吗?

提示:不使用额外空间,首先想到的是使用位运算。

最佳思路:异或运算。

定理:
1.任何数和0异或,是它本身。
2.任何数和自己异或,是0。
3.异或运算满足交换律和结合律。a^b ^ a = b ^ (a ^ a) = b ^ 0 = b。

因为数组中只有一个数字出现一次,其余都出现两次,所以出现两次的数字全部异或之后是0,出现一次的数字和0异或就是最后的结果。

代码如下:

 public int singleNumber(int[] nums) {
        int result = 0;
        for(int num : nums){
            result ^= num;
        }
        return result;
    }

如果不考虑时间复杂度和空间复杂度的限制,这道题有很多种解法,可能的解法有如下几种。

1.使用哈希表存储每个数字和该数字出现的次数。遍历数组即可得到每个数字出现的次数,并更新哈希表,最后遍历哈希表,得到只出现一次的数字。

代码如下:

public static int singleNumber(int[] nums) {
        int len = nums.length;
        Map<Integer,Integer> map = new HashMap<>();
        for (int i =0;i<len;i++){
            int num = nums[i];
            if (!map.containsKey(num)) map.put(num,1);
            else map.put(num,2);
        }
        Set<Integer> mapkeys = map.keySet();
        for (Integer num : mapkeys){
            if (map.get(num) == 1) return num;
        }
        return 0;
	}

2.排序,然后加一个减一个,很无脑

代码如下:

public int singleNumber(int[] nums) {
        Arrays.sort(nums);
        int res = nums[0];
        for (int i = 1; i < nums.length; i++) {
            if (i % 2 == 0) {
                res+=nums[i];
            } else {
                res-=nums[i];
                if (res!=0){
                    res=nums[i-1];
                    break;
                }
            }

        }
        return res;
    }

更多推荐